Index: branches/libIGCM_MPI_OpenMP/libIGCM_sys/libIGCM_sys_titane.ksh
===================================================================
--- branches/libIGCM_MPI_OpenMP/libIGCM_sys/libIGCM_sys_titane.ksh	(revision 570)
+++ branches/libIGCM_MPI_OpenMP/libIGCM_sys/libIGCM_sys_titane.ksh	(revision 571)
@@ -1294,36 +1626,32 @@
 
 function IGCM_sys_activ_variables {
-    IGCM_debug_PushStack "IGCM_sys_activ_variables"
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_activ_variables"
-    fi
-#    ulimit -s 2097152
-
-    typeset max_omp
-
-    ulimit -s unlimited
-
-    (( max_omp = 0 ))
-    for comp in ${config_ListOfComponents[*]} ; do
+  IGCM_debug_PushStack "IGCM_sys_activ_variables"
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_activ_variables"
+  fi
+
+  typeset max_omp
+
+  ulimit -s unlimited
+
+  (( max_omp = 0 ))
+  for comp in ${config_ListOfComponents[*]} ; do
 	
-	eval ExeNameIn=\${config_Executable_${comp}[0]}
-	eval ExeNameOut=\${config_Executable_${comp}[1]}
-	
+    eval ExeNameIn=\${config_Executable_${comp}[0]}
+    eval ExeNameOut=\${config_Executable_${comp}[1]}
     
-	# Only if we really have an executable for the component :
-	if ( [ "X${ExeNameOut}" != X\"\" ] &&  [ "X${comp}" != "XCPL" ] ) ; then
-	    eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
-
-	    if [ ${comp_proc_omp_loc} -gt ${max_omp} ] ; then
-
-		(( max_omp = comp_proc_omp_loc ))
-	    fi
-	fi
-    done
-    if [ ${max_omp} -gt 1 ] ; then
-	module load openmp/${max_omp}thds
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_activ_variables"
+    # Only if we really have an executable for the component :
+    if ( [ "X${ExeNameOut}" != X\"\" ] &&  [ "X${comp}" != "XCPL" ] ) ; then
+      eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
+      if [ ${comp_proc_omp_loc} -gt ${max_omp} ] ; then
+        (( max_omp = comp_proc_omp_loc ))
+      fi
+    fi
+  done
+  if [ ${max_omp} -gt 1 ] ; then
+    module load openmp/${max_omp}thds
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_activ_variables"
 }
 
@@ -1332,9 +1660,9 @@
 
 function IGCM_sys_desactiv_variables {
-    IGCM_debug_PushStack "IGCM_sys_desactiv_variables"
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_desactiv_variables"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_desactiv_variables"
+  IGCM_debug_PushStack "IGCM_sys_desactiv_variables"
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_desactiv_variables"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_desactiv_variables"
 }
 
@@ -1350,274 +1678,268 @@
 ############################################################
 # Build MPI/OMP scripts
-
 function IGCM_sys_build_execution_scripts 
 {
-    IGCM_debug_PushStack "IGCM_sys_build_execution_scripts" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_build_execution_scripts " $@
-    fi
-    typeset nodes listnodes init_node start_num init_exec comp ExeNameIn ExeNameOut 
-    typeset node_num_current node_current comp_proc_mpi_loc comp_proc_omp_loc 
-    typeset num_corempi nombre_restant_node nombre_restant_comp
-
-    if [ ! -f ${SUBMIT_DIR}/Job_${config_UserChoices_JobName} ]  ; then
-        IGCM_debug_Exit "IGCM_sys_titane build_execution_scripts : Job_${config_UserChoices_JobName} doesn't exist in SUBMIT_DIR : ${SUBMIT_DIR} "
-    fi
-
-    if ( ${OK_PARA_MPMD} ) ; then
-
-        if [ -f run_file ] ; then
-            IGCM_sys_Rm -f run_file
+  IGCM_debug_PushStack "IGCM_sys_build_execution_scripts" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_build_execution_scripts " $@
+  fi
+  typeset nodes listnodes init_node start_num init_exec comp ExeNameIn ExeNameOut 
+  typeset node_num_current node_current comp_proc_mpi_loc comp_proc_omp_loc 
+  typeset num_corempi nombre_restant_node nombre_restant_comp
+
+  if [ ! -f ${SUBMIT_DIR}/Job_${config_UserChoices_JobName} ]  ; then
+    IGCM_debug_Exit "IGCM_sys_titane build_execution_scripts : Job_${config_UserChoices_JobName} doesn't exist in SUBMIT_DIR : ${SUBMIT_DIR} "
+  fi
+
+  if ( ${OK_PARA_MPMD} ) ; then
+
+    if [ -f run_file ] ; then
+      IGCM_sys_Rm -f run_file
+    fi
+    touch run_file
+
+    if ( ${OK_PARA_OMP} ) ; then
+
+      #  Hosts treatment
+
+      ${HOST_MPIRUN_COMMAND} hostname | sort | uniq > hosts.tmp
+	
+      i=0
+      rm -f hosts
+      IGCM_debug_Print 1 "sys Titane, Hosts avaible :"
+      for nodes in `cat hosts.tmp` ; do
+        host[$i]=$nodes
+        echo "${host[$i]} slots=8 max_slots=8" >> hosts
+        IGCM_debug_Print 1 ${host[$i]}
+        i=$((i+1))
+      done
+      rm -f hosts.tmp
+	    
+      listnodes=${host[*]}
+	    
+      EXECUTION="${HOST_MPIRUN_COMMAND} -hostfile hosts" 
+	
+      # Initialisation
+
+      init_node=y
+      node_num_current=0
+      start_num=0
+      init_exec=n
+
+      # Test : if oasis is there, we put it at the first position
+	    
+      for comp in ${config_ListOfComponents[*]} ; do
+		
+        if [ "X${comp}" = "XCPL" ]  ; then
+		    
+          eval ExeNameIn=\${config_Executable_${comp}[0]}
+          eval ExeNameOut=\${config_Executable_${comp}[1]}
+		    
+          echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
+          echo ""  >> script_${ExeNameOut}.ksh
+          echo "export KMP_STACKSIZE=3g"  >> script_${ExeNameOut}.ksh
+          echo "export KMP_LIBRARY=turnaround"  >> script_${ExeNameOut}.ksh
+          echo "export MKL_SERIAL=YES"  >> script_${ExeNameOut}.ksh
+          echo "./${ExeNameOut} > out_${ExeNameOut}.out 2>out_${ExeNameOut}.err"  >> script_${ExeNameOut}.ksh
+          IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
+		    
+          init_node=n
+		    
+          (( nombre_restant_node = NUM_COREPERNODE - 1 ))
+          node_num_current=0
+          node_current=${host[${node_num_current}]}
+		    
+          EXECUTION="${EXECUTION} -H ${node_current} -np 1 ./script_${ExeNameOut}.ksh" 
+		    
+          init_exec=y
+          start_num=1
+		    
         fi
-        touch run_file
-
-	if ( ${OK_PARA_OMP} ) ; then
-
-    #  Hosts treatment
-
-	    ${HOST_MPIRUN_COMMAND} hostname | sort | uniq > hosts.tmp
-	
-	    i=0
-	    rm -f hosts
-	    IGCM_debug_Print 1 "sys Titane, Hosts avaible :"
-	    for nodes in `cat hosts.tmp`
-	    do
-		host[$i]=$nodes
-		echo "${host[$i]} slots=8 max_slots=8" >> hosts
-		IGCM_debug_Print 1 ${host[$i]}
-		i=$((i+1))
-	    done
-	    rm -f hosts.tmp
+		
+      done
 	    
-	    listnodes=${host[*]}
+      # Then loop on the components (except for oasis)
+
+      for comp in ${config_ListOfComponents[*]} ; do
+		
+        eval ExeNameIn=\${config_Executable_${comp}[0]}
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+		
+        # Only if we really have an executable for the component :
+        if ( [ "X${ExeNameOut}" != X\"\" ] &&  [ "X${comp}" != "XCPL" ] ) ; then
+
+          eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+          eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
+		    
+          echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
+          # echo "set -vx" >> script_${ExeNameOut}.ksh
+          echo ""  >> script_${ExeNameOut}.ksh
+          echo "export KMP_STACKSIZE=3g"  >> script_${ExeNameOut}.ksh
+          echo "export KMP_LIBRARY=turnaround"  >> script_${ExeNameOut}.ksh
+          echo "export MKL_SERIAL=YES"  >> script_${ExeNameOut}.ksh
+          echo "OMP_NUM_THREADS=${comp_proc_omp_loc}" >> script_${ExeNameOut}.ksh
+          echo "(( MYMPIRANK = OMPI_COMM_WORLD_RANK - ${start_num})) " >>  script_${ExeNameOut}.ksh
+          echo "./${ExeNameOut} > out_${ExeNameOut}.out.\${MYMPIRANK} 2>out_${ExeNameOut}.err.\${MYMPIRANK}"  >> script_${ExeNameOut}.ksh
+          IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
+		    
+          node_num=0
+		    
+          # We define the number of MPI process to be assigned for the component 
+
+          nombre_restant_comp=${comp_proc_mpi_loc}
+		    
+          # Loop on the allocated nodes
+
+          for node in ${listnodes} ; do
+
+            # We go to the current node
+            if [ ${node_num} = ${node_num_current} ] ; then
+
+	      node_current=${host[${node_num_current}]}
+
+              # If first time on the node : initialisation 
+
+              if [ ${init_node} = y ] ; then
+                nombre_restant_node=${NUM_COREPERNODE}
+	      fi
+			    
+              # Test on the number of OMP threads
+
+	      if [ ${comp_proc_omp_loc} -gt ${nombre_restant_node} ] ; then
+                (( node_num = node_num + 1 ))
+                node_num_current=${node_num}
+                init_node=y
+                continue
+              fi
+
+              # Number of MPI process to assign
+
+              (( num_corempi = nombre_restant_node / comp_proc_omp_loc ))
+			    
+	      if [ ${num_corempi} -gt ${nombre_restant_comp} ] ; then
+                num_corempi=${nombre_restant_comp}
+              fi
+
+              (( nombre_restant_node = nombre_restant_node - num_corempi * comp_proc_omp_loc ))
+	      (( nombre_restant_comp = nombre_restant_comp - num_corempi ))
+			    
+	      if [ ${init_exec} = y ] ; then
+                EXECUTION="${EXECUTION} : -H ${node_current} -np ${num_corempi} ./script_${ExeNameOut}.ksh"
+	      else	
+                EXECUTION="${EXECUTION} -H ${node_current} -np ${num_corempi} ./script_${ExeNameOut}.ksh"
+                init_exec=y
+              fi
+
+              ((  start_num = num_corempi + start_num ))
+			    
+            else
+			    
+              (( node_num = node_num + 1 )) 
+ 	      continue
+            fi
+			
+            # Test on the number of core/process remaining on the node/component 
+			
+            if [ ${nombre_restant_node} = 0 ] ; then
+              (( node_num = node_num + 1 ))
+	      node_num_current=${node_num}
+	      init_node=y
+
+              if [ ${nombre_restant_comp} = 0 ] ; then
+                break 1
+              fi
+            else
+
+              node_num_current=${node_num}
+	      init_node=n
+			    
+	      if [ ${nombre_restant_comp} = 0 ] ; then
+	        break 1
+	      fi
+            fi
+          done
+        fi
+      done
 	    
-	    EXECUTION="${HOST_MPIRUN_COMMAND} -hostfile hosts" 
-#	fi
-	
-# Initialisation
-
-	    init_node=y
-	    node_num_current=0
-	    start_num=0
-	    init_exec=n
-
-
-# Test : if oasis is there, we put it at the first position
-	    
-	    for comp in ${config_ListOfComponents[*]} ; do
+    else
+
+      # Then first loop on the components for the coupler ie oasis
+
+      ### the coupler ie oasis must be the first one
+      for comp in ${config_ListOfComponents[*]} ; do
 		
-		if [ "X${comp}" = "XCPL" ]  ; then
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+		
+        # for CPL component only
+        if [ "X${comp}" = "XCPL" ] ; then
+
+          eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
 		    
-		    eval ExeNameIn=\${config_Executable_${comp}[0]}
-		    eval ExeNameOut=\${config_Executable_${comp}[1]}
+          if ( ${OK_PARA_MPI} ) ; then 
+            (( mpi_count = 1 ))
+            until [ ${mpi_count} -gt ${comp_proc_mpi_loc} ] ; do
+              echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut}" >> run_file 
+              (( mpi_count = mpi_count + 1 ))
+            done
+          else
+            echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut} " >> run_file 
+          fi
+        fi
+      done
+
+      # Then second loop on the components
+
+      for comp in ${config_ListOfComponents[*]} ; do
+		
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+		
+        # Only if we really have an executable for the component and not the coupler ie oasis:
+        if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${comp}" != "XCPL" ] ) ; then
+
+          eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
 		    
-		    echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
-		    echo ""  >> script_${ExeNameOut}.ksh
-		    echo "export KMP_STACKSIZE=3g"  >> script_${ExeNameOut}.ksh
-		    echo "export KMP_LIBRARY=turnaround"  >> script_${ExeNameOut}.ksh
-		    echo "export MKL_SERIAL=YES"  >> script_${ExeNameOut}.ksh
-		    echo "./${ExeNameOut} > out_${ExeNameOut}.out 2>out_${ExeNameOut}.err"  >> script_${ExeNameOut}.ksh
-		    IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
-		    
-		    init_node=n
-		    
-		    (( nombre_restant_node = NUM_COREPERNODE - 1 ))
-		    node_num_current=0
-		    node_current=${host[${node_num_current}]}
-		    
-		    EXECUTION="${EXECUTION} -H ${node_current} -np 1 ./script_${ExeNameOut}.ksh" 
-		    
-		    init_exec=y
-		    start_num=1
-		    
-		fi
+          if ( ${OK_PARA_MPI} ) ; then 
+
+            (( mpi_count = 1 ))
+ 	    until [ ${mpi_count} -gt ${comp_proc_mpi_loc} ] ; do
+              echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut}" >> run_file 
+              (( mpi_count = mpi_count + 1 ))
+            done
+          else
+            echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut} " >> run_file 
+          fi
+        fi
+      done
+      IGCM_sys_Chmod u+x run_file
+
+      EXECUTION="${HOST_MPIRUN_COMMAND} --app ./run_file"
+	  
+    fi
+
+  else # Only one executable. launch it.
+
+    for comp in ${config_ListOfComponents[*]} ; do
+
+      # Only if we really have an executable for the component :
+      eval ExeNameOut=\${config_Executable_${comp}[1]}
+      if ( [ "X${ExeNameOut}" != X\"\" ] ) ; then	
 		
-	    done
-	    
-# Then loop on the components (except for oasis)
-
-	    for comp in ${config_ListOfComponents[*]} ; do
-		
-		eval ExeNameIn=\${config_Executable_${comp}[0]}
-		eval ExeNameOut=\${config_Executable_${comp}[1]}
-		
-		
-	# Only if we really have an executable for the component :
-		if ( [ "X${ExeNameOut}" != X\"\" ] &&  [ "X${comp}" != "XCPL" ] ) ; then
-
-		    eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
-		    eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
-		    
-		    echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
-#		echo "set -vx" >> script_${ExeNameOut}.ksh
-		    echo ""  >> script_${ExeNameOut}.ksh
-		    echo "export KMP_STACKSIZE=3g"  >> script_${ExeNameOut}.ksh
-		    echo "export KMP_LIBRARY=turnaround"  >> script_${ExeNameOut}.ksh
-		    echo "export MKL_SERIAL=YES"  >> script_${ExeNameOut}.ksh
-		    echo "OMP_NUM_THREADS=${comp_proc_omp_loc}" >> script_${ExeNameOut}.ksh
- 		    echo "(( MYMPIRANK = OMPI_COMM_WORLD_RANK - ${start_num})) " >>  script_${ExeNameOut}.ksh
-		    echo "./${ExeNameOut} > out_${ExeNameOut}.out.\${MYMPIRANK} 2>out_${ExeNameOut}.err.\${MYMPIRANK}"  >> script_${ExeNameOut}.ksh
-		    IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
-		    
-		    node_num=0
-		    
-# We define the number of MPI process to be assigned for the component 
-
-		    nombre_restant_comp=${comp_proc_mpi_loc}
-		    
-# Loop on the allocated nodes
-
-		    for node in ${listnodes} ; do
-
-# We go to the current node
-
-			if [ ${node_num} = ${node_num_current} ] ; then
-
-			    node_current=${host[${node_num_current}]}
-
-# If first time on the node : initialisation 
-
-			    if [ ${init_node} = y ] ; then
-				nombre_restant_node=${NUM_COREPERNODE}
-			    fi
-			    
-# Test on the number of OMP threads
-
-			    if [ ${comp_proc_omp_loc} -gt ${nombre_restant_node} ] ; then
-				(( node_num = node_num + 1 ))
-				node_num_current=${node_num}
-				init_node=y
-				continue
-			    fi
-
-# Number of MPI process to assign
-
-			    (( num_corempi = nombre_restant_node / comp_proc_omp_loc ))
-			    
-			    if [ ${num_corempi} -gt ${nombre_restant_comp} ] ; then
-				num_corempi=${nombre_restant_comp}
-			    fi
-
-			    (( nombre_restant_node = nombre_restant_node - num_corempi * comp_proc_omp_loc ))
-			    (( nombre_restant_comp = nombre_restant_comp - num_corempi ))
-			    
-			    if [ ${init_exec} = y ] ; then
-				EXECUTION="${EXECUTION} : -H ${node_current} -np ${num_corempi} ./script_${ExeNameOut}.ksh"
-			    else	
-				EXECUTION="${EXECUTION} -H ${node_current} -np ${num_corempi} ./script_${ExeNameOut}.ksh"
-				init_exec=y
-			    fi
-
-			    ((  start_num = num_corempi + start_num ))
-			    
-			else
-			    
-			    (( node_num = node_num + 1 )) 
-			    continue
-			fi
-			
-# Test on the number of core/process remaining on the node/component 
-			
-			if [ ${nombre_restant_node} = 0 ] ; then
-			    (( node_num = node_num + 1 ))
-			    node_num_current=${node_num}
-			    init_node=y
-
-			    if [ ${nombre_restant_comp} = 0 ] ; then
-				break 1
-			    fi
-			else
-
-			    node_num_current=${node_num}
-			    init_node=n
-			    
-			    if [ ${nombre_restant_comp} = 0 ] ; then
-				break 1
-			    fi
-			fi
-		    done
-		fi
-	    done
-	    
+        echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
+	echo ""  >> script_${ExeNameOut}.ksh
+        if ( ${OK_PARA_OMP} ) ; then 
+          echo "OMP_NUM_THREADS=${comp_proc_omp_loc}" >> script_${ExeNameOut}.ksh	
+        fi
+	if  ( ${OK_PARA_MPI} ) ; then 
+          # Attention : a voir si sur 1 proc mais non //
+          echo "./${ExeNameOut} > out_${ExeNameOut}.out.\${OMPI_COMM_WORLD_RANK} 2>out_${ExeNameOut}.err.\${OMPI_COMM_WORLD_RANK}"  >> script_${ExeNameOut}.ksh
+          IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
+          EXECUTION="${HOST_MPIRUN_COMMAND} ./script_${ExeNameOut}.ksh"
 	else
-
- # Then first loop on the components for the coupler ie oasis
-
-### the coupler ie oasis must be the first one
-	    for comp in ${config_ListOfComponents[*]} ; do
-		
-		eval ExeNameOut=\${config_Executable_${comp}[1]}
-		
-	# for CPL component only
-		if [ "X${comp}" = "XCPL" ] ; then
-
-		    eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
-		    
-		    if ( ${OK_PARA_MPI} ) ; then 
-			(( mpi_count = 1 ))
-			until [ ${mpi_count} -gt ${comp_proc_mpi_loc} ] ; do
-			    echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut}" >> run_file 
-			    (( mpi_count = mpi_count + 1 ))
-			done
-		    else
-			echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut} " >> run_file 
-		    fi
-		fi
-	    done
-
-# Then second loop on the components
-
-	    for comp in ${config_ListOfComponents[*]} ; do
-		
-		eval ExeNameOut=\${config_Executable_${comp}[1]}
-		
-	# Only if we really have an executable for the component and not the coupler ie oasis:
-		if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${comp}" != "XCPL" ] ) ; then
-
-		    eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
-		    
-		    if ( ${OK_PARA_MPI} ) ; then 
-
-			(( mpi_count = 1 ))
-			until [ ${mpi_count} -gt ${comp_proc_mpi_loc} ] ; do
-			    echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut}" >> run_file 
-			    (( mpi_count = mpi_count + 1 ))
-			done
-		    else
-			echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut} " >> run_file 
-		    fi
-		fi
-	    done
-	    IGCM_sys_Chmod u+x run_file
-
-	    EXECUTION="${HOST_MPIRUN_COMMAND} --app ./run_file"
-	  
-	fi
-
-    else # Only one executable. launch it.
-
-	for comp in ${config_ListOfComponents[*]} ; do
-
-	# Only if we really have an executable for the component :
-	    eval ExeNameOut=\${config_Executable_${comp}[1]}
-	    if ( [ "X${ExeNameOut}" != X\"\" ] ) ; then	
-		
-		echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
-		echo ""  >> script_${ExeNameOut}.ksh
-		if ( ${OK_PARA_OMP} ) ; then 
-		    echo "OMP_NUM_THREADS=${comp_proc_omp_loc}" >> script_${ExeNameOut}.ksh	
-		fi
-		if  ( ${OK_PARA_MPI} ) ; then 
-# Attention : a voir si sur 1 proc mais non //
-		    echo "./${ExeNameOut} > out_${ExeNameOut}.out.\${OMPI_COMM_WORLD_RANK} 2>out_${ExeNameOut}.err.\${OMPI_COMM_WORLD_RANK}"  >> script_${ExeNameOut}.ksh
-		    IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
-		    EXECUTION="${HOST_MPIRUN_COMMAND} ./script_${ExeNameOut}.ksh"
-		else
-		    EXECUTION="time ./${ExeNameOut}"
-		fi
-	    fi
-	done
-
-    fi
+          EXECUTION="time ./${ExeNameOut}"
+        fi
+      fi
+    done
+
+  fi
 
   IGCM_debug_Print 1 "sys Titane : La commande d execution est "
@@ -1632,169 +1954,204 @@
 # NCO OPERATOR
 
+function IGCM_sys_ncap2 {
+  IGCM_debug_PushStack "IGCM_sys_ncap2" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncap2 :" $@
+  fi
+  ncap2 "$@"
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncap2 : erreur ${@}."
+    IGCM_debug_Exit "ncap2"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncap2"
+}
+
 function IGCM_sys_ncatted {
-    IGCM_debug_PushStack "IGCM_sys_ncatted" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncatted :" $@
-    fi
-    ncatted "$@"
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncatted : erreur ${@}."
-       IGCM_debug_Exit "ncatted"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncatted"
+  IGCM_debug_PushStack "IGCM_sys_ncatted" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncatted :" $@
+  fi
+  ncatted "$@"
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncatted : erreur ${@}."
+    IGCM_debug_Exit "ncatted"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncatted"
 }
 
 function IGCM_sys_ncbo {
-    IGCM_debug_PushStack "IGCM_sys_ncbo" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncbo :" $@
-    fi
-    ncbo $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncbo : erreur ${@}."
-       IGCM_debug_Exit "ncbo"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncbo"
+  IGCM_debug_PushStack "IGCM_sys_ncbo" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncbo :" $@
+  fi
+  ncbo $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncbo : erreur ${@}."
+    IGCM_debug_Exit "ncbo"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncbo"
 }
 
 function IGCM_sys_ncdiff {
-    IGCM_debug_PushStack "IGCM_sys_ncdiff" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncdiff :" $@
-    fi
-    ncdiff $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncdiff : erreur ${@}."
-       IGCM_debug_Exit "ncdiff"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncdiff"
+  IGCM_debug_PushStack "IGCM_sys_ncdiff" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncdiff :" $@
+  fi
+  ncdiff $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncdiff : erreur ${@}."
+    IGCM_debug_Exit "ncdiff"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncdiff"
 }
 
 function IGCM_sys_ncea {
-    IGCM_debug_PushStack "IGCM_sys_ncea" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncea :" $@
-    fi
-    ncea $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncea : erreur ${@}."
-       IGCM_debug_Exit "ncea"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncea"
+  IGCM_debug_PushStack "IGCM_sys_ncea" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncea :" $@
+  fi
+  ncea $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncea : erreur ${@}."
+    IGCM_debug_Exit "ncea"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncea"
 }
 
 function IGCM_sys_ncecat {
-    IGCM_debug_PushStack "IGCM_sys_ncecat" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncecat :" $@
-    fi
-    ncecat $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncecat : erreur ${@}."
-       IGCM_debug_Exit "ncecat"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncecat"
+  IGCM_debug_PushStack "IGCM_sys_ncecat" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncecat :" $@
+  fi
+  ncecat $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncecat : erreur ${@}."
+    IGCM_debug_Exit "ncecat"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncecat"
 }
 
 function IGCM_sys_ncflint {
-    IGCM_debug_PushStack "IGCM_sys_ncflint" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncflint :" $@
-    fi
-    ncflint $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncflint : erreur ${@}."
-       IGCM_debug_Exit "ncflint"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncflint"
+  IGCM_debug_PushStack "IGCM_sys_ncflint" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncflint :" $@
+  fi
+  ncflint $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncflint : erreur ${@}."
+    IGCM_debug_Exit "ncflint"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncflint"
 }
 
 function IGCM_sys_ncks {
-    IGCM_debug_PushStack "IGCM_sys_ncks" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncks :" $@
-    fi
-    ncks $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncks : erreur ${@}."
-       IGCM_debug_Exit "ncks"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncks"
+  IGCM_debug_PushStack "IGCM_sys_ncks" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncks :" $@
+  fi
+  ncks $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncks : erreur ${@}."
+    IGCM_debug_Exit "ncks"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncks"
 }
 
 function IGCM_sys_ncpdq {
-    IGCM_debug_PushStack "IGCM_sys_ncpdq" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncpdq :" $@
-    fi
-    ncpdq $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncpdq : erreur ${@}."
-       IGCM_debug_Exit "ncpdq"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncpdq"
+  IGCM_debug_PushStack "IGCM_sys_ncpdq" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncpdq :" $@
+  fi
+  ncpdq $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncpdq : erreur ${@}."
+    IGCM_debug_Exit "ncpdq"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncpdq"
 }
 
 function IGCM_sys_ncra {
-    IGCM_debug_PushStack "IGCM_sys_ncra" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncra :" $@
-    fi
-    ncra $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncra : erreur ${@}."
-       IGCM_debug_Exit "ncra"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncra"
+  IGCM_debug_PushStack "IGCM_sys_ncra" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncra :" $@
+  fi
+  ncra $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncra : erreur ${@}."
+    IGCM_debug_Exit "ncra"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncra"
 }
 
 function IGCM_sys_ncrcat {
-    IGCM_debug_PushStack "IGCM_sys_ncrcat" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncrcat :" $@
-    fi
-    ncrcat $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncrcat : erreur ${@}."
+  IGCM_debug_PushStack "IGCM_sys_ncrcat" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncrcat :" $@
+  fi
+  ncrcat $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncrcat : erreur ${@}."
 #       IGCM_debug_Exit "ncrcat"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncrcat"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncrcat"
 }
 
 function IGCM_sys_ncrename {
-    IGCM_debug_PushStack "IGCM_sys_ncrename" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncrename :" $@
-    fi
-    ncrename $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncrename : erreur ${@}."
-       IGCM_debug_Exit "ncrename"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncrename"
+  IGCM_debug_PushStack "IGCM_sys_ncrename" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncrename :" $@
+  fi
+  ncrename $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncrename : erreur ${@}."
+    IGCM_debug_Exit "ncrename"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncrename"
 }
 
 function IGCM_sys_ncwa {
-    IGCM_debug_PushStack "IGCM_sys_ncwa" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncwa :" $@
-    fi
-    ncwa $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncwa : erreur ${@}."
-       IGCM_debug_Exit "ncwa"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncwa"
-}
+  IGCM_debug_PushStack "IGCM_sys_ncwa" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncwa :" $@
+  fi
+  ncwa $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncwa : erreur ${@}."
+    IGCM_debug_Exit "ncwa"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncwa"
+}
+
+##############################################################
+# CDO OPERATOR
+
+function IGCM_sys_cdo {
+  IGCM_debug_PushStack "IGCM_sys_cdo" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_cdo :" $@
+  fi
+  \cdo $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_cdo : erreur ${@}."
+    IGCM_debug_PopStack "IGCM_sys_cdo"
+    return 1
+  else
+    IGCM_debug_PopStack "IGCM_sys_cdo"
+    return 0
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_cdo"
+}
Index: branches/libIGCM_MPI_OpenMP/libIGCM_sys/libIGCM_sys_ulam.ksh
===================================================================
--- branches/libIGCM_MPI_OpenMP/libIGCM_sys/libIGCM_sys_ulam.ksh	(revision 570)
+++ branches/libIGCM_MPI_OpenMP/libIGCM_sys/libIGCM_sys_ulam.ksh	(revision 571)
@@ -101,11 +101,10 @@
 #====================================================
 #- ARCHIVE
-# modified 17/10/2011 /u to be used for file stored on gaya
-if (tty -s ) then 
-typeset -r ARCHIVE=${HOMEGAYA}
-else
-typeset -r ARCHIVE=$(echo ${HOMEGAYA}|sed 's,/homegaya/,/u/',)
+# modified 17/10/2011 /u to be used for file stored on gaya 
+if (tty -s ) then  
+    typeset -r ARCHIVE=${HOMEGAYA} 
+else 
+    typeset -r ARCHIVE=$(echo ${HOMEGAYA}|sed 's,/homegaya/,/u/',) 
 fi
-
 
 #====================================================
@@ -119,4 +118,8 @@
 
 #====================================================
+#- R_BUF  Buffer to pack files stored on Master
+typeset -r R_BUF=${WORKDIR}/BUFFER_IGCM
+
+#====================================================
 #- OUT_POST
 typeset -r R_OUT_POST=${WORKDIR}/IGCM_OUT
@@ -128,5 +131,5 @@
 #====================================================
 #- Max number of arguments passed to nco operator or demigration command
-UNIX_MAX_LIMIT=12
+UNIX_MAX_LIMIT=120
 
 #D-#==================================================
@@ -378,7 +381,7 @@
 	echo "IGCM_sys_TestDirArchive :" $@
     fi
-    typeset ExistFlag DirNameToTest
-    # modified 17/10/2011 /u is not known on ulam, use /homegaya instead to test dir locally on ulam
-    DirNameToTest=$(echo $1 | sed 's,/u/,/homegaya/,')
+    typeset ExistFlag DirNameToTest 
+    # modified 17/10/2011 /u is not known on ulam, use /homegaya instead to test dir locally on ulam 
+    DirNameToTest=$(echo $1 | sed 's,/u/,/homegaya/,') 
     ExistFlag=$( [ -d ${DirNameToTest} ] && echo 0 || echo 1 )
     IGCM_debug_PopStack "IGCM_sys_TestDirArchive"
@@ -397,8 +400,8 @@
 	echo "IGCM_sys_TestFileArchive :" $@
     fi
-    typeset ExistFlag FileNameToTest
-    # modified 17/10/2011 /u is not known on ulam, use /homegaya instead to test dir locally on ulam
-    FileNameToTest=$(echo $1 | sed 's,/u/,/homegaya/,')
-    ExistFlag=$( IGCM_sys_RshArchive "[ -f ${FileNameToTest} ] && echo 0 || echo 1" )
+    typeset ExistFlag FileNameToTest 
+    # modified 17/10/2011 /u is not known on ulam, use /homegaya instead to test dir locally on ulam 
+    FileNameToTest=$(echo $1 | sed 's,/u/,/homegaya/,') 
+    ExistFlag=$( IGCM_sys_RshArchive "[ -f ${FileNameToTest} ] && echo 0 || echo 1" ) 
     IGCM_debug_PopStack "IGCM_sys_TestFileArchive"
 
@@ -491,4 +494,5 @@
 	IGCM_debug_Exit "IGCM_sys_QsubPost"
     fi
+
     IGCM_debug_PopStack "IGCM_sys_QsubPost"
 }
